/*
   Dragon v1.0       
                                                                      
  ¿ File       : DEMO.PRG                                   
   Ŵ Description: Dragon library demonstration program       
    Ŵ Usage      : Shows the Dragon D&D capabilities by       
      Ŵ              draging a file name to the file viewer     
        Ŵ              server                                     
           Notice     : Copyright (c) 1994 - MAGMA Software        
                All rights reserved                        
                                                                      
  ٰ
    

          Ŀ
                 Ŀ ķ ķ Ŀ Ŀ ķ ķ       
                                               
                                             
                      Ķ   ķ      Ķ       
                                                  
                                                  
                            Ľ                  
          ĿķĿĿ     ķķĿ
                                                
                                                
          ķ    Ĵ          ĶĽĴ
                                            
                                             
          ĽĽ            Ľ        ٳ
                                                            
                        Dragon v-1.0  (c) 1994              
             Drag-and-Drop utility for ProVision:Windows    
           5396 Bourret Ave., Montreal, PQ, H3X 1J2, Canada 
                           CIS: 73777,2704                  
          
*/

#INCLUDE "pw.ch"
#INCLUDE "Dragon.ch"
#INCLUDE "Directry.ch"


//-----------------------------------------------------------------------
FUNCTION Main()

  LOCAL GetList  := {}
  LOCAL laFile   := LoadDir()
  LOCAL laSkip
  LOCAL loTB
  LOCAL loWinDir
  LOCAL loMenuDir
  LOCAL loWinVew


  CLS

  SET COLOR TO "W+/B, N/W,,, W/B"


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//Initialize PVW
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  INIT WINDOWS                                                          ;
       GRAPHIC  MOUSE                                                   ;
       GRAPHIC  BORDERS                                                 ;
       GRAPHIC  CONTROLS                                                ;
       SETBLINK .F.

  SET WALLPAPER TO PWWP_GRID COLOR "W/N"

  DispBegin()

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//Enable Dragon system
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  INIT DRAGONS


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//Setup SERVER/RECEIVING Dragon window
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  CREATE WINDOW       loWinVew                                          ;
         AT            1, 13                                            ;
         SIZE         22, 66                                            ;
         VIRTUAL SIZE 25, 80                                            ;
         TITLE        "File viewing"                                    ;
         STYLE        PWSTYLE_MDIPRIMARY -                              ;
                      PWSTYLEINFO_MENU                                  ;
         SHADOW

  loWinVew:HotScroll( .T. )

  OPEN WINDOW loWinVew


  DRAGON loWinVew SERVER { | cFile | FileViewNP( loWinVew, cFile ) }


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//Setup CLIENT/SENDER Dragon window
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  laSkip := aSkipNew( 1, Len( laFile ) )
  loTB   := TBrowseNew()
  loTB:AddColumn( tbColumnNew( "", { || laFile[ laSkip[ 1 ] ] } ) )
  loTB:GoTopBlock    := { ||    aGoTop( laSkip )    }
  loTB:GoBottomBlock := { ||    aGoBottom( laSkip ) }
  loTB:SkipBlock     := { | n | aSkip( laSkip, n )  }
  loTB:HeadSep       := " "

  CREATE TBROWSE                                                        ;
         WINDOW  loWinDir                                               ;
         AT      00, 00                                                 ;
         SIZE    14, 20                                                 ;
         USING   loTB                                                   ;
         STYLE   PWSTYLE_PRIMARY        -                               ;
                 PWSTYLEINFO_SIZING     -                               ;
                 PWSTYLEINFO_HSCROLLBAR                                 ;
         TITLE   "File selection"                                       ;
         SHADOW

  loWinDir:HotScroll( .T. )

  MENU loMenuDir
         MENUITEM PROMPT "E~xit"                                        ;
                  ACTION { || DragonIntro(),                            ;
                              loWinVew:Close(),                         ;
                              loWinDir:Close()                          ;
                         }

         MENUITEM PROMPT "\t~About "                                    ;
                  ACTION { || DragonIntro() }
  END MENU

  ATTACH MENU loMenuDir TO loWinDir

  OPEN WINDOW loWinDir


  DRAGON loWinDir CLIENT { || laFile[ laSkip[ 1 ] ] }

  DispEnd()

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//Enable PVW system
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ACTIVATE WINDOWS


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//Disable Dragon system
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  DEINIT DRAGONS


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//Disable PVW system
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  DEINIT WINDOWS


RETURN( NIL )


//-----------------------------------------------------------------------
// Notepad window
//-----------------------------------------------------------------------
STATIC FUNCTION FileViewNp( poPrimary, pcFileName )

  LOCAL loWin

  LOCAL lnMRow
  LOCAL lnMCol
  LOCAL lnWRow
  LOCAL lnWCol

  pcFileName := AllTrim( pcFileName )

  pw():MouseGetPos( @lnMRow, @lnMCol )
  poPrimary:ScreenToWnd( lnMRow, lnMCol, @lnWRow, @lnWCol )

  CREATE NOTEPAD                                                        ;
         WINDOW        loWin                                            ;
         AT            lnWRow, lnWCol ; //05, 04                                           ;
         SIZE          20, 70                                           ;
         STYLE         PWSTYLE_MDISECONDARY                             ;
         PARENT        poPrimary                                        ;
         TITLE         "File viewer (" + pcFileName + ")"               ;
         BUFFERSIZE    32768                                            ;
         MAXLINES        385                                            ;
         LINELENGTH       85                                            ;
         VIRTUAL SIZE  25, 80                                           ;
         READONLY                                                       ;
         SHADOW

  loWin:Store( PWNP_NOWRAP, MemoRead( pcFileName ) )
  loWin:Display()

  loWin:Open()

RETURN( NIL )


//-----------------------------------------------------------------------
// Load current directory files (size <= 32K)
//-----------------------------------------------------------------------
STATIC FUNCTION LoadDir()

  LOCAL laDir
  LOCAL laFile := {}

  laDir := Directory( "*.*" )

  aEval( laDir,                                                         ;
         { | aFile | iif( aFile[ F_SIZE ] <= 32768,                     ;
                          aAdd( laFile, PadR( aFile[ F_NAME ], 12 ) ),  ;
                          .T.                                           ;
                        )                                               ;
         }                                                              ;
       )

RETURN( laFile )
